CF1399B Gifts Fixing

原题链接:http://codeforces.com/problemset/problem/1399/B

Gifts Fixing

You have n gifts and you want to give all of them to children. Of course, you don’t want to offend anyone, so all gifts should be equal between each other. The i-th gift consists of ai candies and bi oranges.

During one move, you can choose some gift 1≤i≤n and do one of the following operations:

eat exactly one candy from this gift (decrease ai by one);
eat exactly one orange from this gift (decrease bi by one);
eat exactly one candy and exactly one orange from this gift (decrease both ai and bi by one).
Of course, you can not eat a candy or orange if it’s not present in the gift (so neither ai nor bi can become less than zero).

As said above, all gifts should be equal. This means that after some sequence of moves the following two conditions should be satisfied: a1=a2=⋯=an and b1=b2=⋯=bn (and ai equals bi is not necessary).

Your task is to find the minimum number of moves required to equalize all the given gifts.

You have to answer t independent test cases.

Input

The first line of the input contains one integer t (1≤t≤1000) — the number of test cases. Then t test cases follow.

The first line of the test case contains one integer n (1≤n≤50) — the number of gifts. The second line of the test case contains n integers a1,a2,…,an (1≤ai≤109), where ai is the number of candies in the i-th gift. The third line of the test case contains n integers b1,b2,…,bn (1≤bi≤109), where bi is the number of oranges in the i-th gift.

Output

For each test case, print one integer: the minimum number of moves required to equalize all the given gifts.

Example
input

5
3
3 5 6
3 2 3
5
1 2 3 4 5
5 4 3 2 1
3
1 1 1
2 2 2
6
1 1000000000 1000000000 1000000000 1000000000 1000000000
1 1 1 1 1 1
3
10 12 8
7 5 4

output

6
16
0
4999999995
7

Note

In the first test case of the example, we can perform the following sequence of moves:

choose the first gift and eat one orange from it, so a=[3,5,6] and b=[2,2,3];
choose the second gift and eat one candy from it, so a=[3,4,6] and b=[2,2,3];
choose the second gift and eat one candy from it, so a=[3,3,6] and b=[2,2,3];
choose the third gift and eat one candy and one orange from it, so a=[3,3,5] and b=[2,2,2];
choose the third gift and eat one candy from it, so a=[3,3,4] and b=[2,2,2];
choose the third gift and eat one candy from it, so a=[3,3,3] and b=[2,2,2].

题目大意

t t t组询问,每次给出数列长度 n n n以及两个长度为 n n n的数列 { a i } \{a_i\} {ai} { b i } \{b_i\} {bi}

有三种操作: a i − 1 ,   b i − 1 a_i-1,\ b_i-1 ai1, bi1以及 a i , b i a_i,b_i ai,bi同时 − 1 -1 1

问最少多少步以后可以让两个数列变成常数数列。

题解

很显然的贪心,要让整个数列变成常数列,最优的做法就是把每个数都减成所在数列的最小值。

同时,因为有同时减一的操作,同一位置上的数需要花费的总步数为与最小值的差较大的数与最小值的差。

代码

含泪复习三目运算。

记得开 l o n g   l o n g long\ long long long

#include
using namespace std;
int t,a,minc,mino;
long long ans;
int can[55],ora[55];
void in()
{
	ans=0,minc=1e9+5,mino=1e9+5;
	scanf("%d",&a);
	for(int i=1;i<=a;++i)
	{
		scanf("%d",&can[i]);
		minc=can[i]<minc?can[i]:minc;
	}
	for(int i=1;i<=a;++i)
	{
		scanf("%d",&ora[i]);
		mino=ora[i]<mino?ora[i]:mino;
	}
}
void ac()
{
	for(int i=1;i<=a;++i)
	ans+=max(can[i]-minc,ora[i]-mino);
	printf("%lld\n",ans);
}
int main()
{
	scanf("%d",&t);
	for(int i=1;i<=t;++i){in(),ac();}
} 

你可能感兴趣的:(杂============,贪心)